﻿package {
	/*
	copyright Qwaz(qwazpia@gmail.com)

	MIT License
	Anime Plugin v1.2

	http://blog.naver.com/yechan54/10136420918
	*/

	import com.qwazlab.NamemaN.Plugin;
	import flash.events.Event;
	
	public class Anime extends Plugin {
		private var searchPattern:RegExp = /^ (\[.*\])? [_\s]* (.*?) [_\s]+ (?:[\-#제第E]|Ep)? [_\s]* ((?:\d+(?:\.\d)?|OP|ED)(?=$|[_\s화話s]|ns)) (?:[화話s]|ns)? (.*?(?=$|(?:[_\s]*\([^()]{5,}\)))) [_\s]* (\([^()]{5,}\))? $/xi
		private var resultPattern:String;
		
		public function Anime():void {
			_pluginName = 'Anime';
			_version = 1.2;
			
			convertForm.addEventListener(Event.CHANGE, propertyChanged);
			includedWord.addEventListener(Event.CHANGE, propertyChanged);
		}
		
		override public function update():void {
			var tmp:String = convertForm.text;
			tmp = tmp.replace(/\?r/g, '$1');
			tmp = tmp.replace(/\?n/g, '$2');
			tmp = tmp.replace(/\?e/g, '$3');
			tmp = tmp.replace(/\?x/g, '$4');
			tmp = tmp.replace(/\?c/g, '$5');
			resultPattern = tmp;
		}
		
		override public function convert(input:String):String {
			if(includedWord.text == '' || input.search(includedWord.text) != -1){
				return input.replace(searchPattern, resultPattern);
			} else {
				return input;
			}
		}
		
		private function propertyChanged(e:Event):void {
			if(this.updateExternal != null) this.updateExternal();
		}
	}
}
